org.h2.pagestore.db

## Class PageBtreeNode

- java.lang.Object
- - org.h2.util.CacheObject
  - - org.h2.pagestore.Page
    - - org.h2.pagestore.db.PageBtree
      - - org.h2.pagestore.db.PageBtreeNode

All Implemented Interfaces:
  java.lang.Comparable<CacheObject>

    public class PageBtreeNode
    extends PageBtree

A b-tree node page that contains index data. Format:

- page type: byte
- checksum: short
- parent page id (0 for root): int
- index id: varInt
- count of all children (-1 if not known): int
- entry count: short
- rightmost child page id: int
- entries (child page id: int, offset: short)

The row contains the largest key of the respective child, meaning row[0] contains the largest key of child[0].

### Field Summary

### Fields inherited from class org.h2.pagestore.db.PageBtree

`data, entryCount, index, offsets, onlyPosition, parentPageId, rows, start, written`

### Fields inherited from class org.h2.pagestore.Page

`changeCount, FLAG_LAST, TYPE_BTREE_LEAF, TYPE_BTREE_NODE, TYPE_DATA_LEAF, TYPE_DATA_NODE, TYPE_DATA_OVERFLOW, TYPE_EMPTY, TYPE_FREE_LIST, TYPE_STREAM_DATA, TYPE_STREAM_TRUNK`

### Fields inherited from class org.h2.util.CacheObject

`cacheChained, cacheNext, cachePrevious`

### Method Summary

Methods
`void` `moveTo(Session session, int newPos)` Copy the data to a new location, change the parent to point to the new location, and free up the current page.
`static Page` `read(PageBtreeIndex index, Data data, int pageId)` Read a b-tree node page.
`protected void` `remapChildren()` Update the parent id of all children.
`java.lang.String` `toString()`
`void` `write()` Write the page.

### Methods inherited from class org.h2.pagestore.db.PageBtree

`canRemove, getMemory, memoryChange, readAllRows`

### Methods inherited from class org.h2.pagestore.Page

`add, canMove, insert, insert, insert, remove, remove, remove`

### Methods inherited from class org.h2.util.CacheObject

`compareTo, getPos, isChanged, isStream, setChanged, setPos`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### read

    public static Page read(PageBtreeIndex index,
            Data data,
            int pageId)

Read a b-tree node page.

Parameters:
  `index` - the index
  `data` - the data
  `pageId` - the page id
Returns:
  the page

#### remapChildren

    protected void remapChildren()

Description copied from class: `PageBtree`
Update the parent id of all children.

#### write

    public void write()

Description copied from class: `Page`
Write the page.

Specified by:
  `write` in class `Page`

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`

#### moveTo

    public void moveTo(Session session,
              int newPos)

Description copied from class: `Page`
Copy the data to a new location, change the parent to point to the new location, and free up the current page.

Specified by:
  `moveTo` in class `Page`
Parameters:
  `session` - the session
  `newPos` - the new position